/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.20 Revision 1.112
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.20 2005/09/04 15:15:37 swegener Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.112 2011/12/13 21:44:22 vapier Exp $
4# 4
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# @ECLASS: autotools.eclass
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# @MAINTAINER:
7# 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
8# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
9# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
10#
11# NB: If you add anything, please comment it!
12 12
13inherit eutils gnuconfig 13if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
14___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
14 15
15#DEPEND="sys-devel/automake 16inherit eutils libtool
16# sys-devel/autoconf
17# sys-devel/libtool"
18#
19# Ebuilds should rather depend on the proper version of the tool.
20 17
21# Variables: 18# @ECLASS-VARIABLE: WANT_AUTOCONF
22# 19# @DESCRIPTION:
23# AT_M4DIR - Additional director(y|ies) aclocal should search 20# The major version of autoconf your package needs
24# AT_GNUCONF_UPDATE - Should gnuconfig_update() be run (normally handled by 21: ${WANT_AUTOCONF:=latest}
25# econf()) [yes|no]
26 22
27# Functions: 23# @ECLASS-VARIABLE: WANT_AUTOMAKE
28# 24# @DESCRIPTION:
29# eautoreconf() - Should do a full autoreconf - normally what most people 25# The major version of automake your package needs
30# will be interested in. Also should handle additional 26: ${WANT_AUTOMAKE:=latest}
31# directories specified by AC_CONFIG_SUBDIRS.
32# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
33# to search for macro's.
34# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
35# with elibtoolize() from libtool.eclass
36# eautoconf - Runs autoconf.
37# eautoheader - Runs autoheader.
38# eautomake - Runs automake
39#
40 27
28# @ECLASS-VARIABLE: WANT_LIBTOOL
29# @DESCRIPTION:
30# Do you want libtool? Valid values here are "latest" and "none".
31: ${WANT_LIBTOOL:=latest}
32
33# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
34# @INTERNAL
35# @DESCRIPTION:
36# CONSTANT!
37# The latest major version/slot of automake available on each arch.
38# If a newer version is stable on any arch, and is NOT reflected in this list,
39# then circular dependencies may arise during emerge @system bootstraps.
40# Do NOT change this variable in your ebuilds!
41_LATEST_AUTOMAKE='1.11'
42
43_automake_atom="sys-devel/automake"
44_autoconf_atom="sys-devel/autoconf"
45if [[ -n ${WANT_AUTOMAKE} ]]; then
46 case ${WANT_AUTOMAKE} in
47 none) _automake_atom="" ;; # some packages don't require automake at all
48 # if you change the "latest" version here, change also autotools_run_tool
49 # this MUST reflect the latest stable major version for each arch!
50 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;;
51 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
52 esac
53 export WANT_AUTOMAKE
54fi
55
56if [[ -n ${WANT_AUTOCONF} ]] ; then
57 case ${WANT_AUTOCONF} in
58 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
59 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
60 # if you change the “latest” version here, change also autotools_run_tool
61 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;;
62 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
63 esac
64 export WANT_AUTOCONF
65fi
66
67_libtool_atom="sys-devel/libtool"
68if [[ -n ${WANT_LIBTOOL} ]] ; then
69 case ${WANT_LIBTOOL} in
70 none) _libtool_atom="" ;;
71 latest) ;;
72 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
73 esac
74 export WANT_LIBTOOL
75fi
76
77AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
78RDEPEND=""
79
80# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
81# @DESCRIPTION:
82# Set to 'no' to disable automatically adding to DEPEND. This lets
83# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
84# their own DEPEND string.
85: ${AUTOTOOLS_AUTO_DEPEND:=yes}
86if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
87 DEPEND=${AUTOTOOLS_DEPEND}
88fi
89
90unset _automake_atom _autoconf_atom
91
92# @ECLASS-VARIABLE: AM_OPTS
93# @DEFAULT_UNSET
94# @DESCRIPTION:
95# Additional options to pass to automake during
96# eautoreconf call.
97
98# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
99# @DEFAULT_UNSET
100# @DESCRIPTION:
101# Don't run elibtoolize command if set to 'yes',
102# useful when elibtoolize needs to be ran with
103# particular options
104
41# XXX: M4DIR should be depreciated 105# XXX: M4DIR should be deprecated
106# @ECLASS-VARIABLE: AT_M4DIR
107# @DESCRIPTION:
108# Additional director(y|ies) aclocal should search
42AT_M4DIR=${AT_M4DIR:-${M4DIR}} 109: ${AT_M4DIR:=${M4DIR}}
43AT_GNUCONF_UPDATE="no"
44 110
45 111# @FUNCTION: eautoreconf
112# @DESCRIPTION:
46# This function mimes the behavior of autoreconf, but uses the different 113# This function mimes the behavior of autoreconf, but uses the different
47# eauto* functions to run the tools. It doesn't accept parameters, but 114# eauto* functions to run the tools. It doesn't accept parameters, but
48# the directory with include files can be specified with AT_M4DIR variable. 115# the directory with include files can be specified with AT_M4DIR variable.
49# 116#
50# Note: doesn't run autopoint right now, but runs gnuconfig_update. 117# Should do a full autoreconf - normally what most people will be interested in.
118# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
51eautoreconf() { 119eautoreconf() {
52 local pwd=$(pwd) x 120 local x auxdir g
53 121
122 if [[ -z ${AT_NO_RECURSIVE} ]]; then
54 # Take care of subdirs 123 # Take care of subdirs
55 for x in $(autotools_get_subdirs); do 124 for x in $(autotools_get_subdirs); do
56 if [[ -d ${x} ]] ; then 125 if [[ -d ${x} ]] ; then
57 cd "${x}" 126 pushd "${x}" >/dev/null
58 eautoreconf 127 AT_NOELIBTOOLIZE="yes" eautoreconf
59 cd "${pwd}" 128 popd >/dev/null
60 fi 129 fi
61 done 130 done
131 fi
62 132
133 auxdir=$(autotools_get_auxdir)
134
135 einfo "Running eautoreconf in '${PWD}' ..."
136 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
63 eaclocal 137 eaclocal
138 [[ ${CHOST} == *-darwin* ]] && g=g
139 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
140 _elibtoolize --copy --force --install
141 else
64 _elibtoolize --copy --force 142 _elibtoolize --copy --force
143 fi
65 eautoconf 144 eautoconf
66 eautoheader 145 eautoheader
67 eautomake 146 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
68 147
69 # Normally run by econf() 148 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
70 [[ ${AT_GNUCONF_UPDATE} == "yes" ]] && gnuconfig_update
71}
72 149
150 # Call it here to prevent failures due to elibtoolize called _before_
151 # eautoreconf. We set $S because elibtoolize runs on that #265319
152 S=${PWD} elibtoolize --force
153
154 return 0
155}
156
157# @FUNCTION: eaclocal_amflags
158# @DESCRIPTION:
159# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
160# (most) of the crazy crap that people throw at us.
161eaclocal_amflags() {
162 local aclocal_opts amflags_file
163
164 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
165 [[ -e ${amflags_file} ]] || continue
166 # setup the env in case the pkg does something crazy
167 # in their ACLOCAL_AMFLAGS. like run a shell script
168 # which turns around and runs autotools. #365401
169 # or split across multiple lines. #383525
170 autotools_env_setup
171 aclocal_opts=$(sed -n \
172 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
173 # match the first line
174 s:[^=]*=::p; \
175 # then gobble up all escaped lines
176 : nextline /\\\\$/{ n; p; b nextline; } \
177 }" ${amflags_file})
178 eval aclocal_opts=\""${aclocal_opts}"\"
179 break
180 done
181
182 echo ${aclocal_opts}
183}
184
185# @FUNCTION: eaclocal
186# @DESCRIPTION:
73# These functions runs the autotools using autotools_run_tool with the 187# These functions runs the autotools using autotools_run_tool with the
74# specified parametes. The name of the tool run is the same of the function 188# specified parametes. The name of the tool run is the same of the function
75# without e prefix. 189# without e prefix.
76# They also force installing the support files for safety. 190# They also force installing the support files for safety.
191# Respects AT_M4DIR for additional directories to search for macro's.
77eaclocal() { 192eaclocal() {
78 local aclocal_opts
79
80 # XXX: M4DIR should be depreciated
81 AT_M4DIR=${AT_M4DIR:-${M4DIR}}
82
83 if [[ -n ${AT_M4DIR} ]] ; then
84 for x in ${AT_M4DIR} ; do
85 case "${x}" in
86 "-I")
87 # We handle it below
88 ;;
89 "-I"*)
90 # Invalid syntax, but maybe we should help out ...
91 ewarn "eaclocal: Proper syntax is (note the space after '-I'): aclocal -I <dir>"
92 aclocal_opts="${aclocal_opts} -I ${x}"
93 ;;
94 *)
95 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
96 aclocal_opts="${aclocal_opts} -I ${x}"
97 ;;
98 esac
99 done
100 fi
101
102 [[ -f aclocal.m4 && -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 193 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
103 autotools_run_tool aclocal "$@" ${aclocal_opts} 194 autotools_run_tool aclocal $(autotools_m4dir_include) "$@" $(eaclocal_amflags)
104} 195}
105 196
197# @FUNCTION: _elibtoolize
198# @DESCRIPTION:
199# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
200# libtool.eclass.
106_elibtoolize() { 201_elibtoolize() {
107 local opts 202 local opts g=
108 203
109 # Check if we should run libtoolize 204 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
205 # check for both it and the current AC_PROG_LIBTOOL)
110 [[ -n $(autotools_check_macro "AC_PROG_LIBTOOL") ]] || return 0 206 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
111 207
112 [[ -f Makefile.am ]] && opts="--automake" 208 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
113 209
114 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize" 210 [[ ${CHOST} == *-darwin* ]] && g=g
115 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 211 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
116 212
117 # Need to rerun aclocal 213 # Need to rerun aclocal
118 eaclocal 214 eaclocal
119} 215}
120 216
217# @FUNCTION: eautoheader
218# @DESCRIPTION:
219# Runs autoheader.
121eautoheader() { 220eautoheader() {
122 # Check if we should run autoheader 221 # Check if we should run autoheader
123 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 222 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
124 autotools_run_tool autoheader "$@" 223 NO_FAIL=1 autotools_run_tool autoheader $(autotools_m4dir_include) "$@"
125} 224}
126 225
226# @FUNCTION: eautoconf
227# @DESCRIPTION:
228# Runs autoconf.
127eautoconf() { 229eautoconf() {
128 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 230 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
129 echo 231 echo
130 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 232 eerror "No configure.{ac,in} present in '${PWD}'!"
131 echo 233 echo
132 die "No configure.{ac,in} present!" 234 die "No configure.{ac,in} present!"
133 fi 235 fi
134 236
135 autotools_run_tool autoconf "$@" 237 autotools_run_tool autoconf $(autotools_m4dir_include) "$@"
136} 238}
137 239
240# @FUNCTION: eautomake
241# @DESCRIPTION:
242# Runs automake.
138eautomake() { 243eautomake() {
244 local extra_opts
245 local makefile_name
246
247 # Run automake if:
248 # - a Makefile.am type file exists
249 # - a Makefile.in type file exists and the configure
250 # script is using the AM_INIT_AUTOMAKE directive
251 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do
252 [[ -f ${makefile_name} ]] && break
253 done
139 [[ -f Makefile.am ]] || return 0 254 [[ -z ${makefile_name} ]] && return 0
255
256 if [[ ${makefile_name} == *.in ]] ; then
257 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then
258 return 0
259 fi
260
261 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
262 local used_automake
263 local installed_automake
264
265 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
266 sed -e 's:.*(GNU automake) ::')
267 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
268 sed -e 's:.*by automake \(.*\) from .*:\1:')
269
270 if [[ ${installed_automake} != ${used_automake} ]]; then
271 einfo "Automake used for the package (${used_automake}) differs from"
272 einfo "the installed version (${installed_automake})."
273 eautoreconf
274 return 0
275 fi
276 fi
277
278 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
279 || extra_opts="${extra_opts} --foreign"
280
140 # --force-missing seems not to be recognized by some flavours of automake 281 # --force-missing seems not to be recognized by some flavours of automake
141 autotools_run_tool automake --add-missing --copy "$@" 282 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
142} 283}
143 284
144 285# @FUNCTION: eautopoint
286# @DESCRIPTION:
287# Runs autopoint (from the gettext package).
288eautopoint() {
289 autotools_run_tool autopoint "$@"
290}
145 291
146# Internal function to run an autotools' tool 292# Internal function to run an autotools' tool
293autotools_env_setup() {
294 # We do the “latest” → version switch here because it solves
295 # possible order problems, see bug #270010 as an example.
296 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
297 local pv
298 for pv in ${_LATEST_AUTOMAKE} ; do
299 # has_version respects ROOT, but in this case, we don't want it to,
300 # thus "ROOT=/" prefix:
301 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
302 done
303 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
304 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
305 fi
306 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
307}
147autotools_run_tool() { 308autotools_run_tool() {
309 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
310 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
311 fi
312
313 autotools_env_setup
314
148 local STDERR_TARGET="${T}/$$.out" 315 local STDERR_TARGET="${T}/$1.out"
149 local PATCH_TARGET="${T}/$$.patch" 316 # most of the time, there will only be one run, but if there are
317 # more, make sure we get unique log filenames
318 if [[ -e ${STDERR_TARGET} ]] ; then
150 local ris 319 local i=1
320 while :; do
321 STDERR_TARGET="${T}/$1-${i}.out"
322 [[ -e ${STDERR_TARGET} ]] || break
323 : $(( i++ ))
324 done
325 fi
151 326
152 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 327 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
153 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
154 328
155 ebegin "Running $1" 329 ebegin "Running $@"
156 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 330 "$@" >> "${STDERR_TARGET}" 2>&1
157 ris=$? 331 eend $?
158 eend ${ris}
159 332
160 if [[ ${ris} != 0 ]]; then 333 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
161 echo 334 echo
162 eerror "Failed Running $1 !" 335 eerror "Failed Running $1 !"
163 eerror 336 eerror
164 eerror "Include in your bugreport the contents of:" 337 eerror "Include in your bugreport the contents of:"
165 eerror 338 eerror
166 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 339 eerror " ${STDERR_TARGET}"
167 echo 340 echo
168 die "Failed Running $1 !" 341 die "Failed Running $1 !"
169 fi 342 fi
170} 343}
171 344
172# Internal function to check for support 345# Internal function to check for support
173autotools_check_macro() { 346autotools_check_macro() {
174 [[ -f configure.ac || -f configure.in ]] && \ 347 [[ -f configure.ac || -f configure.in ]] || return 0
175 autoconf --trace=$1 2>/dev/null 348 local macro
349 for macro ; do
350 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
351 done
176 return 0 352 return 0
177} 353}
178 354
355# Internal function to look for a macro and extract its value
356autotools_check_macro_val() {
357 local macro=$1 scan_out
358
359 autotools_check_macro "${macro}" | \
360 gawk -v macro="${macro}" \
361 '($0 !~ /^[[:space:]]*(#|dnl)/) {
362 if (match($0, macro ":(.*)$", res))
363 print res[1]
364 }' | uniq
365
366 return 0
367}
368
179# Internal function to get additional subdirs to configure 369# Internal function to get additional subdirs to configure
180autotools_get_subdirs() { 370autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
181 local subdirs_scan_out 371autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
182 372
183 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 373autotools_m4dir_include() {
184 [[ -n ${subdirs_scan_out} ]] || return 0 374 [[ -n ${AT_M4DIR} ]] || return
185 375
186 echo "${subdirs_scan_out}" | gawk \ 376 local include_opts=
187 '($0 !~ /^[[:space:]]*(#|dnl)/) {
188 if (match($0, "AC_CONFIG_SUBDIRS\\(\\[?([^\\])]*)", res)) {
189 split(res[1], DIRS, /[\])]/)
190 print DIRS[1]
191 }
192 }' | uniq
193 377
194 return 0 378 for x in ${AT_M4DIR} ; do
195} 379 case "${x}" in
380 "-I")
381 # We handle it below
382 ;;
383 *)
384 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
385 include_opts="${include_opts} -I ${x}"
386 ;;
387 esac
388 done
196 389
390 echo $include_opts
391}
392
393fi

Legend:
Removed from v.1.20  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.20